<template>
    <div class="flex">
        <div class="w-0"></div>
        <div class="w-full flex justify-center">
            <section
                class="w-11/12 md:w-1/3 flex justify-center rounded-lg shadow p-1 bg-orange-200"
            >
                <article v-if="!skipped" class="relative bg-white w-full rounded">
                    <figure
                        class="absolute right-0 top-0 -mt-3 -mr-3 flex justify-center items-center bg-orange-200 border w-6 h-6 z-10 p-6 rounded-full"
                    >
                        <span class>{{ timer.seconds}}</span>
                    </figure>
                    <h1 class="text-3xl">{{AD.title}}</h1>

                    <div class="video-container">
                        <span ref="video" id="video"></span>
                    </div>
                    <div
                        v-if="!timer.started"
                        id="playAdWrapper"
                        class="w-full h-full absolute top-0 flex flex-col justify-end z-10"
                    ></div>
                </article>
                <article v-if="skipped" class="bg-white w-full rounded flex flex-col items-center">
                    <figure class="mb-20 my-2 w-full p-2">
                        <img :src="AD.posterImgUrl" alt="brave browser icon" />
                    </figure>
                    <button
                        class="bg-orange-500 hover:bg-orange-700 text-white font-bold py-2 px-4 rounded my-2"
                    >
                        <a :href="AD.url">
                            <h1 class="text-2xl">Get Brave Browser</h1>
                        </a>
                    </button>
                </article>
                <div class="fixed bottom-0 mb-8 flex w-full justify-center">
                    <button
                        v-if="!timer.done  && !skipped"
                        @click="playAd"
                        class="bg-orange-500 hover:bg-orange-700 text-white font-bold py-2 px-4 rounded"
                    >
                        <h1 class="text-2xl">Watch Ad</h1>
                    </button>
                    <button
                        v-if="timer.done && !skipped"
                        @click="skipAd"
                        class="bg-orange-500 hover:bg-orange-700 text-white font-bold py-2 px-4 rounded"
                    >
                        <h1 class="text-2xl">Skip Ad</h1>
                    </button>
                    <button
                        v-if="skipped"
                        @click="goToSummary"
                        class="bg-white hover:bg-orange-200 text-orange-500 border-2 border-orange-500 font-bold py-2 px-4 rounded"
                    >
                        <h1 class="text-2xl">Go To Summary</h1>
                    </button>
                </div>
            </section>
        </div>
        <div class="w-0"></div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { State } from 'vuex-class'
import { IAdState, IAd } from '@/app/Sales/Ads/types/ad'
import YTPlayer from 'yt-player'

class Timer {
    private timer: number
    public seconds: number
    public done: boolean
    public started: boolean

    constructor(miliseconds: number) {
        this.seconds = miliseconds / 1000
        this.done = false
    }

    start() {
        this.started = true
        this.timer = setInterval(() => {
            this.seconds--
            if (this.seconds <= 0) {
                this.done = true
                this.started = false
                this.clear()
            }
        }, 1000)
    }

    clear() {
        clearTimeout(this.timer)
    }
}

@Component
export default class App extends Vue {
    @State('Ads')
    ADS_STATE: IAdState

    AD: IAd = {
        name: '',
        title: '',
        url: '',
        videoUrl: '',
        posterImgUrl: '',
        popupImgUrl: '',
    }
    timer: Timer = new Timer(5000)
    player: YTPlayer | null = null
    skipped: boolean = false

    // LiferCycle
    mounted() {
        if (this.ADS_STATE.ads !== undefined) {
            this.AD.title = this.ADS_STATE.ads[0].title
            this.AD.url = this.ADS_STATE.ads[0].url
            this.AD.posterImgUrl = this.ADS_STATE.ads[0].posterImgUrl

            const video = this.$refs.video as HTMLElement
            this.player = new YTPlayer(video)
            this.player.load(
                this.getYoutubeVideo(this.ADS_STATE.ads[0].videoUrl)
            )
        }
    }

    beforeDestroy() {
        if (this.timer !== null) this.timer.clear()
    }

    // Methods
    playAd() {
        if (this.player !== null) {
            this.player.play()
            this.player.on('playing', () => {
                this.timer.start()
            })
        }
    }

    skipAd() {
        this.skipped = true
    }
    goToSummary() {
        this.$router.push('/account')
    }
    getYoutubeVideo(videoURL: string) {
        let video_id = videoURL.split('v=')[1]
        var ampersandPosition = video_id.indexOf('&')
        if (ampersandPosition != -1) {
            video_id = video_id.substring(0, ampersandPosition)
        }
        return video_id
    }
}
</script>

<style lang="css">
.video-container {
    position: relative;
    padding-bottom: 56.25%;
    padding-top: 0;
    height: 0;
    overflow: hidden;
}

.video-container iframe,
.video-container object,
.video-container embed {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
}
#playAdWrapper {
    background-image: linear-gradient(rgba(255, 0, 0, 0), white);
}
</style>
